﻿
using System;
using System.Drawing;
using Wisej.Web;

namespace Wisej.CustomCellEditor
{
	public partial class Window1 : Form
	{
		public Window1()
		{
			InitializeComponent();
		}

		private void Window1_Load(object sender, EventArgs e)
		{
			for (int i = 0; i < 10;i++ )
			{
				this.dataGridView1.Columns.Add("Col" + i, "Col " + i);
			}

			this.dataGridView1.RowCount = 1000;
		}

		private void dataGridView1_CellBeginEdit(object sender, DataGridViewCellCancelEventArgs e)
		{
			var column = this.dataGridView1.Columns[e.ColumnIndex];
			var cell = this.dataGridView1[e.ColumnIndex, e.RowIndex];

			switch (e.RowIndex % 5)
			{
				case 0:
					var dateTimePicker = new DateTimePicker();
					dateTimePicker.Text = cell.FormattedValue;
					column.Editor = dateTimePicker;
					break;

				case 1:
					var comboBox = new ComboBox();
					comboBox.DropDownStyle = ComboBoxStyle.DropDown;
					comboBox.Items.Add("One");
					comboBox.Items.Add("Two");
					comboBox.Items.Add("Three");
					comboBox.Text = cell.FormattedValue;
					column.Editor = comboBox;
					break;

				case 2:
					var spinner = new NumericUpDown();
					if (cell.Value is int)
						spinner.Value = (int)cell.Value;
					column.Editor = spinner;
					break;

				case 3:
					var trackBar = new TrackBar();
					trackBar.BackColor = SystemColors.Window;
					trackBar.Orientation = Orientation.Horizontal;
					if (cell.Value is int)
						trackBar.Value = (int)cell.Value;
					column.Editor = trackBar;
					break;

				case 4:
					var textBox = new TextBox();
					textBox.AutoCompleteList = new string[] {"One", "Two", "Three" };
					textBox.Text = cell.FormattedValue;
					column.Editor = textBox;
					break;
			}
		}

		private void dataGridView1_CellEndEdit(object sender, DataGridViewCellEventArgs e)
		{
			var column = this.dataGridView1.Columns[e.ColumnIndex];
			var cell = this.dataGridView1[e.ColumnIndex, e.RowIndex];

			switch (e.RowIndex % 5)
			{
				// Not needed, the DataGridView will store the Text property in the cell's value.
				//case 0:
				//	var dateTimePicker = (DateTimePicker)column.Editor;
				//	cell.Value = dateTimePicker.Text;
				//	break;

				// Not needed, the DataGridView will store the Text property in the cell's value.
				//case 1:
				//	var comboBox = (ComboBox)column.Editor;
				//	cell.Value = comboBox.Text;
				//	break;

				case 2:
					var spinner = (NumericUpDown)column.Editor;
					cell.Value = spinner.Value;
					break;

				case 3:
					var trackBar = (TrackBar)column.Editor;
					cell.Value = trackBar.Value;
					break;

					// Not needed, the DataGridView will store the Text property in the cell's value.
					//case 4:
					//	var textBox = (TextBox)column.Editor;
					//	cell.Value = textBox.Text;
					//	break;
			}

		}
	}
}
